<?php
/**
 * $Horde: whups/templates/searchresults.inc,v 1.55 2005/09/04 18:09:47 selsky Exp $
 *
 * Copyright 2001-2005 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/licenses/bsdl.php.
 */
class SearchResults {

    var $_title = '';
    var $_id;

    function SearchResults($title = null)
    {
        Horde::addScriptFile('tables.js', 'whups', true);
        if (!is_null($title)) {
            $this->_title = $title;
        }
        $this->_id = md5(uniqid(mt_rand()));
    }

    /**
     * Displays the set of tickets in $results. Also saves those tickets into
     * a cookie for back/forth search navigation.
     */
    function results(&$results, &$values)
    {
        global $prefs;

        $ids = array();
        foreach ($results as $info) {
            $ids[] = $info['id'];
        }
        $_SESSION['whups_tickets'] = $ids;
?>

<!-- Results Begin -->
<table width="100%" cellspacing="0">
 <tr>
  <td class="header nowrap" align="left"><?php echo $this->_title . ' (' . count($results) . ')' ?></td>
  <td class="header nowrap" align="right"><span class="smallheader">
    <?php if (Auth::getAuth() && count($results)): ?>
    <form action="<?php echo Horde::downloadUrl('report.html', null, Horde::applicationUrl('data.php')) ?>" method="post" name="datagen">
      <?php Util::pformInput() ?>
      <input type="hidden" name="ids" value="<?php echo implode(',', $ids) ?>" />
      <?php echo _("Save these results as: ") ?>
      <select name="template">
        <?php foreach (Whups::listTemplates('searchresults') as $name => $label): ?>
          <option value="<?php echo $name ?>"><?php echo htmlspecialchars($label) ?></option>
        <?php endforeach; ?>
      </select>
      <input type="submit" class="button" value="<?php echo _("Save") ?>" />
    </form>
  <?php endif; ?>
  </span></td>
 </tr>
</table>
<?php if (count($results)): ?>
<table class="headerbox linedRow sortable" id="sresults_<?php echo $this->_id ?>" width="100%" cellspacing="0">
<?php
     $sortby  = $prefs->getValue('sortby');
     $sortdir = $prefs->getValue('sortdir');

     echo '<tr class="item">';
     foreach ($values as $name => $value) {
         $formvars = array_merge($_GET, $_POST, array('sortby' => $value));
         unset($formvars['_formvars']);
         $url = Util::addParameter(Horde::selfUrl(), $formvars);

         if ($sortby == $value) {
             $class = ' selected';
             $revurl = Util::addParameter($url, 'sortdir', ($sortdir ? 0 : 1));
             $revimg = Horde::img($sortdir ? 'za.png' : 'az.png', _("Sort Direction"), '', $GLOBALS['registry']->getImageDir('horde'));
             $sortlink = Horde::link($revurl, sprintf(_("Sort by %s"), $name)) . $name . '&nbsp;' . $revimg . '</a> ';
         } else {
             $class = '';
             $rsortlink = '';
             $sortlink = Horde::link($url, sprintf(_("Sort by %s"), $name)) . $name . '</a> ';
         }

         echo '<th align="left" class="nowrap' . $class . '">' . $sortlink . '</th>';
     }
     echo '</tr>';

     foreach ($results as $info) {
         echo '<tr>';

         $url = Horde::applicationUrl(Util::addParameter('ticket/', 'id', $info['id']));

         foreach ($values as $name => $value) {
             $thevalue = isset($info[$value]) ? $info[$value] : '';

             if ($value == 'timestamp' || $value == 'date_assigned' ||
                 $value == 'date_resolved') {
                 $thevalue = Horde_Form_Type_date::getFormattedTime($thevalue, $prefs->getValue('report_time_format'), false);
             } elseif ($value == 'id' || $value == 'summary') {
                 $thevalue = Horde::link($url, isset($info['summary']) ? $info['summary'] : '') . '<strong>' . htmlspecialchars($thevalue) . '</strong></a>';
             } elseif ($value == 'owners') {
                 if (!empty($info['owners'])) {
                     $owners = array();
                     foreach ($thevalue as $owner) {
                         $owners[] = Whups::formatUser($owner, false);
                     }
                     $thevalue = implode(', ', $owners);
                 }
             }

             $class = ($sortby == $value) ? ' class="linedRowSelectedCol"' : '';
             echo '<td' . $class . '>' . (strlen($thevalue) ? $thevalue : '&nbsp;') . '</td>';
         }
     }
?>
</table>
<?php endif; ?>
<!-- Results End -->
<br class="spacer" />
<?php
    }

}
